
__author__="Austin"
__date__ ="$30-Aug-2009 11:17:05 AM$"

from maingame import Ppnbrds
from gameEnt import *
import sys
import pygame
from pygame import *

class Game:
    def __init__(self):
        pygame.init()
        self.screen = pygame.display.set_mode((640, 480))
        self.ents = []
        self.Aents = []
        self.Rents = []
        self.activeents = []
        self.mode = Ppnbrds(self)
        self.clock = pygame.time.Clock()
        self.tix = pygame.time.get_ticks()
        
        self.player = Player(self, 31.5 * 320, 31.5 * 240 - 32)
        self.keyflag = 0

    def start(self):
        darp = 0
        while 1:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    sys.exit(0)
            self.think()
            x, y = self.player.getPos()
            self.mode.cam[0] = int(x - 152)
            self.mode.cam[1] = int(y - 112)
            self.draw()
            self.clock.tick(60)
            for event in pygame.event.get():
                if (event.type == KEYDOWN):
                    if event.key == K_LEFT:
                        self.keyflag |= 4
                    elif event.key == K_RIGHT:
                        self.keyflag |= 1
                    elif event.key == K_UP:
                        self.keyflag |= 2
                    elif event.key == K_DOWN:
                        self.keyflag |= 8
                    elif event.key == K_z:
                        self.keyflag |= 16
                    elif event.key == K_ESCAPE:
                        sys.exit(0)
                    
                if (event.type == KEYUP):
                    if event.key == K_LEFT:
                        self.keyflag &= 27
                    elif event.key == K_RIGHT:
                        self.keyflag &= 30
                    elif event.key == K_UP:
                        self.keyflag &= 29
                    elif event.key == K_DOWN:
                        self.keyflag &= 23
                    elif event.key == K_z:
                        self.keyflag &= 15

                    
            if darp == 60:
                curtix = pygame.time.get_ticks()
                fch = 1000.0 / ((curtix - self.tix) / darp)
                pygame.display.set_caption('pempenberds! use arrow keys and z to win! Collect ' + str(self.numbirds) + ' birds! ESC to close!')
                self.tix = curtix
                darp = 0
            darp += 1

    def geneggs(self, loclist):
        for egg in loclist:
            Bird(self, (egg[0] + 0.5) * 320, (egg[1] + 0.5) * 240 - 32)
        self.numbirds = len(loclist)


    def addent(self, ent):
        self.Aents.append(ent)

    def rement(self, ent):
        self.Rents.append(ent)

    def think(self):
        del self.activeents[:]

        for ent in self.Aents:
            self.ents.append(ent)
        del self.Aents[:]

        for ent in self.Rents:
            if ent in self.ents:
                self.ents.remove(ent)
        del self.Rents[:]
        for ent in self.ents:
            x, y = ent.getPos()
            if x >= self.mode.cam[0] - 20 and x <= self.mode.cam[0] + 340:
                if y >= self.mode.cam[1] - 20 and y <= self.mode.cam[1] + 260:
                    self.activeents.append(ent)
        if len(self.activeents) > 0:
            for ent in self.activeents:
                ent.move()

                ex, ey = ent.getPos()

                mask = self.mode.map.get_collide(ex + (ent.w * 0.5), ey + (ent.h * 0.5))
                if not mask == 15:
                    ent.onCollideWorld(mask)
                for o in self.activeents:
                    if not o == ent:
                        ox, oy = o.getPos()
                        if abs(ox - ex) < 8:
                            if abs(oy - ey) < 16:
                                ent.onCollideEnt(o)

            for ent in self.activeents:
                ent.think()

        self.mode.think()

    def draw(self):
        scr = self.mode.draw()

        if len(self.activeents) > 0:
            for ent in self.activeents:
                    ent.draw(scr, self.mode.cam[0], self.mode.cam[1])
        scr = pygame.transform.scale2x(scr)

        self.screen.blit(scr, (0,0))
        pygame.display.flip()
        