import os.path

__author__="Austin"
__date__ ="$30-Aug-2009 11:25:49 AM$"

import pygame
import os
from pygame.locals import *

# these lines jacked from skellington framework
data_py = os.path.abspath(os.path.dirname(__file__))
data_dir = os.path.normpath(os.path.join(data_py, '..', 'data'))

def filepath(filename):
    '''Determine the path to a file in the data directory.
    '''
    return os.path.join(data_dir, filename)
#end skellington

def loadImg(imgname, key = None):
    img = pygame.image.load(filepath(imgname))
    img = img.convert()

    if key is not None:
        if key == -1:
            key = img.get_at((0,0))
        img.set_colorkey(key, RLEACCEL)

    return img, img.get_rect()